import * as i0 from '@angular/core';
import { Injectable, Component, NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';

class AngularFormcontrolsValidationService {
    constructor() { }
    /** this function for validation name fields*/
    nameFieldCheck() {
        var pattern = /^[A-Za-z' \-.]+$/;
        // var pattern =/^[a-zA-Z ]+(?:\s+[a-zA-Z ]+)*.$/;
        return (control) => {
            const inputValue = control.value || '';
            if ((inputValue === null || inputValue === void 0 ? void 0 : inputValue.toString().length) >= 1) {
                if (inputValue.trim() == "sam") {
                    return { 'nameCheck': true };
                }
                if (inputValue[0] == " ") {
                    return { 'emptynotAllowed': true };
                }
                if (!pattern.test(inputValue)) {
                    return { 'specialCharacter': true };
                }
            }
            return null;
        };
    }
    /** this function for email validtion*/
    emailValidation() {
        var emailPattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return (control) => {
            const emailValue = control.value || '';
            if ((emailValue === null || emailValue === void 0 ? void 0 : emailValue.toString().length) >= 1) {
                if (emailValue[0] == " ") {
                    console.log("inside mail");
                    return { 'emptynotAllowed': true };
                }
                if (!emailPattern.test(emailValue)) {
                    return { 'notvalidemail': true };
                }
            }
            return null;
        };
    }
    /** mobile number field validation*/
    numberValidation() {
        return (control) => {
            const check_value = control.value || '';
            if ((check_value === null || check_value === void 0 ? void 0 : check_value.toString().length) >= 1) {
                if ((check_value === null || check_value === void 0 ? void 0 : check_value.toString().length) < 3) {
                    return { "minimumLength": true };
                }
                if ((check_value === null || check_value === void 0 ? void 0 : check_value.toString().length) < 10) {
                    return { "phoneNumberDigit": true };
                }
            }
            return null;
        };
    }
    /**password field validation */
    passwordValidation() {
        return (control) => {
            const passValue = control.value || '';
            if ((passValue === null || passValue === void 0 ? void 0 : passValue.toString().length) >= 1) {
                if (passValue[0] == " ") {
                    return { "emptynotallowed": true };
                }
                if (passValue.length < 7) {
                    return { 'minimumcharacter': true };
                }
                if (passValue.length > 50) {
                    return { 'maximumCharacter': true };
                }
                // var specialcharacterreg = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*#?&])[A-Za-z\d@$!%*#?&]{8,}$/;
                // var specialcharacterreg = /^(?=[^a-z]*[a-z])(?=[^A-Z]*[A-Z])(?=\D*\d)(?=[^@$!%*#?&]*[@$!%*#?&])[A-Za-z\d@$!%*#?&]{8,}$/;
                // var specialcharacterreg =  /^(?=.{8,})(?=.*[a-z])(?=.*[A-Z])(?=.*[@#$%^&+=]).*$/;
                var specialcharacterreg = /^(?=[^a-z]*[a-z])(?=[^A-Z]*[A-Z])(?=\D*\d)(?=[^@$!%*#?&]*[@$!%*#?&])[A-Za-z\d@$!%*#?&]*$/;
                if ((passValue === null || passValue === void 0 ? void 0 : passValue.toString().length) >= 1) {
                    if (!specialcharacterreg.test(passValue)) {
                        return { "strongPassword": true };
                    }
                }
            }
            return null;
        };
    }
    /**confirm password validation */
    confirmPasswordValidators() {
        return (control) => {
            /**                            condtion  (ternay operator)           ?  true : false; */
            return control.value.password == control.value.cpass ? null : { "passwordmismatch": true };
            // if (control.value.password != control.value.cpass) {
            //     console.log('contr !== alue.cpass',control.value.password != control.value.cpass)
            //     return { "passwordmismatch": true };
            // }
            // return null;
        };
    }
    /**strong password validation */
    strongPasswordValidation() {
        return (control) => {
            const passValue = control.value || '';
            var specialcharacterreg = /^(?=[^a-z]*[a-z])(?=[^A-Z]*[A-Z])(?=\D*\d)(?=[^@$!%*#?&]*[@$!%*#?&])[A-Za-z\d@$!%*#?&]{4,}$/;
            if ((passValue === null || passValue === void 0 ? void 0 : passValue.toString().length) >= 1) {
                if (!specialcharacterreg.test(passValue)) {
                    return { "strongPassword": true };
                }
            }
            return null;
        };
    }
    /**future date restriction */
    futureDaterestrict() {
        return (control) => {
            const dateValue = control.value || '';
            if ((dateValue === null || dateValue === void 0 ? void 0 : dateValue.toString().length) >= 1) {
                const currentDate = new Date();
                /** Parse the input date*/
                const parsedInputDate = new Date(dateValue);
                if (parsedInputDate > currentDate) {
                    return { "futureDate": true };
                }
            }
            return null;
        };
    }
}
AngularFormcontrolsValidationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
AngularFormcontrolsValidationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class AngularFormcontrolsValidationComponent {
}
AngularFormcontrolsValidationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AngularFormcontrolsValidationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: AngularFormcontrolsValidationComponent, selector: "lib-angular-formcontrols-validation", ngImport: i0, template: `
    <p>
      angular-formcontrols-validation works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-angular-formcontrols-validation', template: `
    <p>
      angular-formcontrols-validation works!
    </p>
  ` }]
        }] });

class AngularFormcontrolsValidationModule {
}
AngularFormcontrolsValidationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AngularFormcontrolsValidationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationModule, declarations: [AngularFormcontrolsValidationComponent], imports: [FormsModule,
        ReactiveFormsModule], exports: [AngularFormcontrolsValidationComponent] });
AngularFormcontrolsValidationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationModule, imports: [FormsModule,
        ReactiveFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: AngularFormcontrolsValidationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AngularFormcontrolsValidationComponent
                    ],
                    imports: [
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    exports: [
                        AngularFormcontrolsValidationComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of angular-formcontrols-validation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AngularFormcontrolsValidationComponent, AngularFormcontrolsValidationModule, AngularFormcontrolsValidationService };
//# sourceMappingURL=angular-formcontrols-validation.mjs.map
